********************************************************************************
* ɽ ϵήϳ ׻¸ 
*
*     advection-euler-Burgers figure for tex 
*
*   99/05/28 ߷ 
*       99/05/29 ; 
********************************************************************************
      program fig1

      parameter(imax=100,nmax=2)  ! imax: åɿ, nmax: ֤ɽ 
      parameter(dt=2.5,istep=1)   ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(xmin=-50.,xmax=50.,umin=-5.,umax=5.)
      parameter(xdel=5.,udel=1.0)
      parameter(vxmin=0.1,vxmax=0.9,vxc=(vxmax+vxmin)/2)
      parameter(vymmin=0.05,vxmmax=0.95,vy=vxmmax-vymmin)
      parameter(pi=atan(1.)*4)

      real ux(0:imax),uy(0:imax),work(imax+1,3)
      character ctime*10

      common /avai/uy
      external odrkg,fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
* graphic initialize
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call sglset('lcorner',.false.)
      call sglset('lprop', .false. )
      call sgrset('const', 0.02 )

      write(6,*)' WORKSTATION ID (I)  ?;'
      call sgpwsn
      read(5,*)iws

      call gropn(iws)

* initial condition
      t = 0.0
      do i=0,imax
        ux(i) = xmin + (xmax-xmin)*i/imax
        uy(i)   = 5.*sin(2*pi*i/imax)
      end do

      dvy = vy/(nmax+1)
      vyc = vymmin + 0.5*dvy
      vfact = 0.8
      vymin = vyc - vfact*0.5*dvy
      vymax = vyc + vfact*0.5*dvy
      call grfrm
      call grswnd( xmin,  xmax,  umin,  umax)
      call grsvpt(vxmin, vxmax, vymin, vymax)
      call grstrn(1)
      call grstrf

      call sglau(xmin-xdel, 0., xmax+xdel, 0.)
      call sglau(0., umin-udel, 0., umax+udel)

      call sgstxi(2)
      call sgstxs(0.03)
      call sgtxv(vxmax+0.03, vyc-0.03, 'X')
      call sgtxv(vxc-0.03, vymax, 'U')

      call sgstxs(0.035)
      call sgstxc(1)
      ctime = 'T='
      write(ctime(3:5),'(f3.1)') t
      call sgtxv(vxmax, vymax-0.02, ctime)

      call sgspli(2)
      call sgplu(imax+1, ux, uy)

* time integration
      do n=1,nmax
	tend = t + dt
        call odrkdu(imax+1, odrkg, fcn, t, tend, istep, ux, work)

        vyc = vymmin + (0.5+n)*dvy 
        vymin = vyc - vfact*0.5*dvy
        vymax = vyc + vfact*0.5*dvy

        call grfig
        call grswnd( xmin,  xmax,  umin,  umax)
        call grsvpt(vxmin, vxmax, vymin, vymax)
        call grstrn(1)
        call grstrf

        call sglau(xmin-xdel, 0., xmax+xdel, 0.)
        call sglau(0., umin-udel, 0., umax+udel)

        write(ctime(3:5),'(f3.1)') t
        call sgtxv(vxmax, vymax-0.02, ctime)

        call sgplu(imax+1, ux, uy)
      end do

      call grcls

      end
********************************************************************************
      subroutine fcn(k, t, u, du)

      parameter(imax=100)
      real u(0:imax),du(0:imax),uy(0:imax)
      common /avai/uy
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do i=0,imax
        du(i) = uy(i)
      end do

      return
      end
********************************************************************************



