c********************************************************************c
c     stream function and det J                                      c
c********************************************************************c
      program fig2

      parameter(nx=101,ny=51,nx1=17,ny1=9,nx2=5,ny2=3)
      parameter(pi=3.14159)
      parameter(xmin=0.,xmax=2.*pi,ymin=0.,ymax=pi)
      parameter(amp=1.)

      real det(nx,ny),psi(nx,ny)
      real rxy1(nx1),rxy2(nx2)
      character csgi*1,cxy2(nx2)*4
c--------------------------------------------------------------------
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)
      yc   = (ymin+ymax)/2
      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ynin + dely*(j-1)
          psi(i,j) = amp*sin(xx)*sin(yy) - 0.5*(yy - yc)
          det(i,j) = -(cos(xx)*cos(yy))**2+(sin(xx)*sin(yy))**2
        end do
      end do

      axdel1=(xmax-xmin)/(nx1-1)
      do l=1,nx1
        rxy1(l)= xmin + (l-1)*axdel1
      end do 

      axdel2 = (xmax-xmin)/(nx2-1)
      do l=1,nx2
        rxy2(l) = xmin + (l-1)*axdel2
      end do

      cxy2(1) = '0'
      cxy2(2) =        csgi(167) // '/2'
      cxy2(3) =        csgi(167)
      cxy2(4) = '3' // csgi(167) // '/2'
      cxy2(5) = '2' // csgi(167)

      call swiset('iwidth',  720)
      call swiset('iheight', 540)
      call sglset('lcorner',.false.)
      call udpset('lmsg', .false.)
      call udpset('label',.false.)

      write(6,*)' WORKSTATION ID (I)  ?;'
      call sgpwsn
      read(5,*)iws

      call gropn(iws)

      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15, 0.95, 0.10, 0.50)
      call grstrn(1)
      call grstrf

      call uetone(det, nx, nx, ny)
      call udcntr(det, nx, nx, ny)    

      call uxaxlb('b', rxy1, nx1, rxy2, cxy2, 4, nx2)
      call uxaxdv('t', pi/8., pi/2.)
      call uyaxlb('l', rxy1, ny1, rxy2, cxy2, 4, ny2)
      call uyaxdv('r', pi/8., pi/2.)
      call uxsttl('b', 'X', 0.0)
      call uysttl('l', 'Y', 0.0)

      call grfig
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15, 0.95, 0.56, 0.96)
      call grstrn(1)
      call grstrf

      call udgclb(psi, nx, nx, ny, 0.19625)
      call udcntr(psi, nx, nx, ny)

      call uxaxlb('b', rxy1, nx1, rxy2, cxy2, 4, nx2)
      call uxaxdv('t', pi/8., pi/2.)
      call uyaxlb('l', rxy1, ny1, rxy2, cxy2, 4, ny2)
      call uyaxdv('r', pi/8., pi/2.)
      call uysttl('l', 'Y', 0.0)

      call grcls
      end  
