********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ήήβΥ饰󥸥屿ư (4)
*     عԥå  åեå
*                          
*  99/05/10  ͧ
*      99/05/11 ; 
********************************************************************************
      program fig3

      parameter(nmax=248,itmax=5)   ! nmax: γҿ, itmax: ֤׻ 
      parameter(dt=1.2,istep=1)     ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(kmax=8)
      parameter(pi=3.141592)
      parameter(xmin=0.,xmax=2*pi,ymin=0.,ymax=xmax/2)
      parameter(nx=41,ny=21)
      parameter(nx1=17,ny1=9)
      parameter(nx2= 5,ny2=3)

      real r(2),work(2,3)
      real x(0:nmax,0:kmax,0:itmax),y(0:nmax,0:kmax,0:itmax)
      real xoff(0:kmax),yoff(0:kmax)
      real u(nx,ny),v(nx,ny)
      real rxy1(nx1),rxy2(nx2)
      character csgi*1
      character cxy2(nx2)*4

      common /const/amp, u0

      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget( 'rmiss', rmiss )
      call gllset( 'lmiss', .true. )

      amp = 1.

c**** experimental parameters ****c
      xoffst = 0.3927
      yoffst = 1.571
      rlen   = 0.7854
      u0     = 0.5

c**** flow field (u,v) ****c
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)

      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ynin + dely*(j-1)
          if(i.eq.1 .or. i.eq.nx .or. j.eq.1 .or. j.eq.ny) then
            u(i,j) = rmiss
            v(i,j) = rmiss
          else
            u(i,j) = - amp*sin(xx)*cos(yy) + u0
            v(i,j) =   amp*cos(xx)*sin(yy)
          end if
        end do
      end do

c**** initial condition ****c
      t = 0.0
      xoff(0) = xoffst  - rlen/2
      yoff(0) = yoffst  - rlen/2
      xoff(1) = xoff(0)
      yoff(1) = yoff(0)
      xoff(2) = xoff(1) + rlen/2
      yoff(2) = yoff(1)
      xoff(3) = xoff(0) + rlen/4
      yoff(3) = yoff(0) + rlen/4
      xoff(4) = xoff(3) + rlen/2
      yoff(4) = yoff(3)
      xoff(5) = xoff(0) 
      yoff(5) = yoff(0) + rlen/2
      xoff(6) = xoff(5) + rlen/2
      yoff(6) = yoff(5)
      xoff(7) = xoff(0) + rlen/4
      yoff(7) = yoff(0) + rlen*3/4
      xoff(8) = xoff(7) + rlen/2
      yoff(8) = yoff(7)
      do k=0,kmax
        if(k .eq. 0) then
          rl = rlen
        else
          rl = rlen/4
        end if
        do n=1,nmax/4
          dx = rl/(nmax/4)
          x(n         ,k,0) =        dx*(n-1) + xoff(k)
          x(n+  nmax/4,k,0) =   rl            + xoff(k)
          x(n+2*nmax/4,k,0) =   rl - dx*(n-1) + xoff(k)
          x(n+3*nmax/4,k,0) =                 + xoff(k)
          y(n         ,k,0) =                 + yoff(k)
          y(n+  nmax/4,k,0) =        dx*(n-1) + yoff(k)
          y(n+2*nmax/4,k,0) =   rl            + yoff(k)
          y(n+3*nmax/4,k,0) =   rl - dx*(n-1) + yoff(k)
        end do
        x(0,k,0) = x(nmax,k,0)
        y(0,k,0) = y(nmax,k,0)
      end do
  
c**** time-integration ****c
      do i=1,itmax
        tend = t + dt
        do k=0,kmax
          do n=0,nmax
            r(1) = x(n,k,i-1)
            r(2) = y(n,k,i-1)
            call odrkdu(2, odrkg, fcn, t, tend, istep, r, work)
            x(n,k,i) = r(1)
            y(n,k,i) = r(2)
            t = t - tend   !! DCLޥ˥奢MATH2 ODRKDUɤɤͤ뤳
          end do 
        end do 
      end do  

c**** graph ****c
      call swiset('iwidth',  750)
      call swiset('iheight', 450)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)

c**** setup for uzpack ****c
      axdel1 = (xmax-xmin)/(nx1-1)
      do l=1,nx1
        rxy1(l) = xmin + (l-1)*axdel1
      end do

      axdel2 = (xmax-xmin)/(nx2-1)
      do l=1,nx2
        rxy2(l) = xmin + (l-1)*axdel2
      end do

      cxy2(1) = '0'
      cxy2(2) =        csgi(167) // '/2'
      cxy2(3) =        csgi(167)
      cxy2(4) = '3' // csgi(167) // '/2'
      cxy2(5) = '2' // csgi(167)

      write(6,*)' WORKSTATION ID (I)  ?;'
      call sgpwsn
      read(5,*)iws

      call gropn(iws)

      call grfrm
      call grswnd(xmin, xmax, ymin, ymax)
      call grsvpt(0.15, 0.95,  0.1,  0.5)
      call grstrn(1)
      call grstrf

c      call ugiset('index', 91)
      call ugiset('index', 1)
      call uglset('lnrmal', .false.)
      vfact = 0.02
      call ugrset('xfact1', vfact)
      call ugrset('yfact1', vfact)
      call uglset('lmsg', .false.)

      call ugvect(u, nx, v, nx, nx, ny)
      
      call sgstnp(4999)
      call sgspli(42)
      call sgstnp(999)
      call sgspli(2)
      do i=0,itmax
        call sgplu(nmax+1, x(0,0,i), y(0,0,i))
        do k=1,kmax
          call sgtnu(nmax, x(1,k,i), y(1,k,i))
        end do
      end do

      call uxaxlb('b', rxy1, nx1, rxy2, cxy2, 4, nx2)
      call uxaxdv('t', pi/8., pi/2.) 
      call uxsttl('b', 'X', 0.0)
      call uyaxlb('l', rxy1, ny1, rxy2, cxy2, 4, ny2)
      call uyaxdv('r', pi/8., pi/2.) 
      call uysttl('l', 'Y', 0.0)

      call grcls

      stop
      end
********************************************************************************
      subroutine fcn(n,t,x,dx)

      real x(n), dx(n)

      common /const/amp, u0
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx(1) = - amp*sin(x(1))*cos(x(2)) + u0
      dx(2) =   amp*cos(x(1))*sin(x(2))

      return
      end
********************************************************************************


